#ifndef INDIVIDUAL_H
#include "individl.h"
#endif

#ifndef POPULATION_H
#include "populati.h"
#endif

#ifndef GA_H
#define GA_H

class GA {
friend class GAinfo;
friend void change_task_par(double*,GA&);

private:
  population pop;
  task*     task_;
  int       starting_num;   // number of population at start
  double    dpop;           // pop growths to dpop*starting_num till dying off
  double    spec_rad[9];    // radiuses of species
  double    doptimum;       // strictness of search
  int       P_m;            // probablity of mutation : 1/P_m
  int       dying_off_error;// 1:exact, approx starting_num:total random
  void create_offspring();
  void divide(fenotype*,fenotype*);    // most important !
  void put_in_offspr(fenotype*,int=0); // with spec_rad controll
  void immigration_();                 // helps immigration

public:
  GA(task&, int=100, double* a=NULL, double=0.0, signed char=0);
  GA(task&, const individual*, int, double* a=NULL, double=0.0);
  void dpop_(double d) {
         dpop=(int(d*starting_num)>starting_num ? d : dpop); };
  void spec_rad_(int i,double d) {
         spec_rad[i>8 ? 8 : (i<0 ? 0 : i)]=(d>0 ? d : 1); };
  void P_m_(int i) { P_m=(i>1 ? i : 1); };
  void dying_off_error_(int i) {
         dying_off_error=( i>=1 ? (i<=starting_num ? i : starting_num) :
                                   1 ); };
  void activity();
  void immigration(double=1);
  void selection_relaxation(unsigned int i) { pop.sel_relax(i,NULL); };
  void dying_off_relaxation(unsigned int i) { pop.dying_relax(i); };
  void strict(int);
  void freeze() { pop.freeze=1; };
  void thaw() { pop.freeze=0; };
};

#endif