#include <iostream.h>
#include <iomanip.h>
#include <fstream.h>
#include "gainfo.h"

individual GAinfo::maximum(GA& ga,unsigned char* f,signed char a) {
  taxon_chart_t* m=ga.pop.pointer(f);
  if(m==NULL) return ga.pop.taxon_chart.maxe->e; // if invalid species
  ga.pop.max_ind=m->maxe->e;
  ga.pop.maximum(m,a);
  return ga.pop.max_ind;
};

void GAinfo::save(GA& ga,ostream& outfile,int mode) {
  int           i;
  unsigned char sps[8]={ 0,0,0,0,0,0,0,0 };
  signed char   newspec=1;
  outfile << "# A GAS output file.\n#\n";
  switch(mode) {
    case 0: outfile << "# Every individuals.\n# genotype     "; break;
    case 1: outfile << "# Best individuals.\n# genotype     "; break;
    case 2: outfile << "# Every individuals.\n#"; break;
    case 3: outfile << "# Best individuals.\n#"; break;
  };
  outfile << " fenotype       fitness\n";
  outfile.setf(ios::scientific,ios::floatfield);
  ga.pop.iterstart(&ga.pop.taxon_chart);
  do {
    if(newspec) {
      outfile << "#\n# species = " << hex <<
	 int(sps[0]) << "-" << int(sps[1]) << "-" << int(sps[2]) << "-" <<
	 int(sps[3]) << "-" << int(sps[4]) << "-" << int(sps[5]) << "-" <<
	 int(sps[6]) << "-" << int(sps[7]) << "\n" << dec <<
	 "# level = " << ga.pop.iterator->spec->rad_index << "\n" <<
	 "# count = " << ga.pop.iterator->spec->count << "\n#\n";
      newspec=0; };
    switch(mode) {
      case 0: outfile << ga.pop.iterator->e.gen() << "  " <<
			 ga.pop.iterator->e.fen() << "  " <<
			 ga.pop.iterator->e.fit(); break;
      case 1: if(ga.pop.iterator==ga.pop.iterator->spec->maxe)
		outfile << ga.pop.iterator->e.gen() << "  " <<
			 ga.pop.iterator->e.fen() << "  " <<
			 ga.pop.iterator->e.fit(); break;
      case 2: outfile << ga.pop.iterator->e.fen() << "  " <<
			 ga.pop.iterator->e.fit(); break;
      case 3: if(ga.pop.iterator==ga.pop.iterator->spec->maxe)
		outfile << ga.pop.iterator->e.fen() << "  " <<
			 ga.pop.iterator->e.fit(); break;
    };
    if(ga.pop.iterator->e==ga.pop.iterator->spec->maxe->e) {
      outfile << " # <- best\n";
      if(mode==1 || mode==3)
	while(ga.pop.iterator->next != NULL &&
	      ga.pop.iterator->spec == ga.pop.iterator->next->spec)
	  ga.pop.iterator=ga.pop.iterator->next; }
    else if(mode!=1 && mode!=3) outfile << "\n";
    if(ga.pop.iterator->next != NULL &&
       ga.pop.iterator->spec != ga.pop.iterator->next->spec) {
      newspec=1;
      ga.pop.species(ga.pop.iterator->next->spec,sps);
    };
    ga.pop.iterator=ga.pop.iterator->next;
  }
  while(!ga.pop.iter_all_end());
};

