#include "individl.h"

task::task(double* param) : parameter_(param) {; };

void task::new_parameter(double* p) { parameter_=p; };

//---------------------------------------------------------------------------

fitnesst task::fit(fenotype& fen) {
// parameter_[0] : number of function
  int j,i,
      L=(parameter_[1] < BITLENGTH ? (int)parameter_[1] : BITLENGTH);
  long        F=0;
  signed char c;

  switch((int)parameter_[0]) {

    default :
      // subset sum problem
      // parameter_[1] is the size of the set (should be BITLENGTH)
      // parameter_[2] is the C we optimize for
      // parameter_[3],...,parameter[3+size-1] are the elements
      #define C parameter_[2]
      for(i=0; i<(L-1)/CHAR_BIT; ++i) {
	c=fen.fen[i];
	for(j=0; j<CHAR_BIT; ++j,c>>=1)
	  if(c & 1) F+=(long)parameter_[2+L-i*CHAR_BIT-j];
      };
      c=fen.fen[i];
      for(j=0; j<(L-(((L-1)/CHAR_BIT))*CHAR_BIT); ++j,c>>=1)
	if(c & 1) F+=(long)parameter_[2+L-i*CHAR_BIT-j];
      if(C < F) F=-F; else F=F-(long)C;
      return F;
      #undef C
  };
};

//===========================================================================

fenotype task::fen(genotype& gen) {
  fenotype f;
  for(int i=0; i<GT_LENGTH; ++i) f.fen[i]=gen.gen[i];
  return f;
};

//===========================================================================

genotype task::invfen(fenotype& fen) {
  genotype g;
  for(int i=0; i<GT_LENGTH; ++i) g.gen[i]=fen.fen[i];
  return g;
};
